<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.7"/>
<title>TI  Graph Library   (TIGL): tiglMutationManager.hpp Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/search.js"></script>
<script type="text/javascript">
  $(document).ready(function() { searchBox.OnSelectItem(0); });
</script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td style="padding-left: 0.5em;">
   <div id="projectname">TI  Graph Library   (TIGL)
   &#160;<span id="projectnumber">ver1.00.00</span>
   </div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.7 -->
<script type="text/javascript">
var searchBox = new SearchBox("searchBox", "search",false,'Search');
</script>
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="pages.html"><span>Related&#160;Pages</span></a></li>
      <li><a href="modules.html"><span>Modules</span></a></li>
      <li><a href="annotated.html"><span>Classes</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
      <li>
        <div id="MSearchBox" class="MSearchBoxInactive">
        <span class="left">
          <img id="MSearchSelect" src="search/mag_sel.png"
               onmouseover="return searchBox.OnSearchSelectShow()"
               onmouseout="return searchBox.OnSearchSelectHide()"
               alt=""/>
          <input type="text" id="MSearchField" value="Search" accesskey="S"
               onfocus="searchBox.OnSearchFieldFocus(true)" 
               onblur="searchBox.OnSearchFieldFocus(false)" 
               onkeyup="searchBox.OnSearchFieldChange(event)"/>
          </span><span class="right">
            <a id="MSearchClose" href="javascript:searchBox.CloseResultsWindow()"><img id="MSearchCloseImg" border="0" src="search/close.png" alt=""/></a>
          </span>
        </div>
      </li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.html"><span>File&#160;List</span></a></li>
      <li><a href="globals.html"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
<a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(0)"><span class="SelectionMark">&#160;</span>All</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(1)"><span class="SelectionMark">&#160;</span>Classes</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(2)"><span class="SelectionMark">&#160;</span>Files</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(3)"><span class="SelectionMark">&#160;</span>Functions</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(4)"><span class="SelectionMark">&#160;</span>Variables</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(5)"><span class="SelectionMark">&#160;</span>Enumerations</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(6)"><span class="SelectionMark">&#160;</span>Groups</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(7)"><span class="SelectionMark">&#160;</span>Pages</a></div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div id="nav-path" class="navpath">
  <ul>
<li class="navelem"><a class="el" href="dir_e1c3629206a62d7880de84e139cd6012.html">src</a></li><li class="navelem"><a class="el" href="dir_5923310312939235796ca11289acda83.html">common</a></li><li class="navelem"><a class="el" href="dir_cefb8d6b2db0343bb075f98034598653.html">mutation</a></li>  </ul>
</div>
</div><!-- top -->
<div class="header">
  <div class="headertitle">
<div class="title">tiglMutationManager.hpp</div>  </div>
</div><!--header-->
<div class="contents">
<a href="tiglMutationManager_8hpp.html">Go to the documentation of this file.</a><div class="fragment"><div class="line"><a name="l00001"></a><span class="lineno">    1</span>&#160;<span class="preprocessor">#ifndef TIGLMUTATIONMANAGER_HPP_</span></div>
<div class="line"><a name="l00002"></a><span class="lineno">    2</span>&#160;<span class="preprocessor">#define TIGLMUTATIONMANAGER_HPP_</span></div>
<div class="line"><a name="l00003"></a><span class="lineno">    3</span>&#160;</div>
<div class="line"><a name="l00004"></a><span class="lineno">    4</span>&#160;<span class="comment">/*****************************************************************************/</span></div>
<div class="line"><a name="l00008"></a><span class="lineno">    8</span>&#160;<span class="comment">/* Copyright (C) 2015 Texas Instruments Incorporated - http://www.ti.com/</span></div>
<div class="line"><a name="l00009"></a><span class="lineno">    9</span>&#160;<span class="comment"> *</span></div>
<div class="line"><a name="l00010"></a><span class="lineno">   10</span>&#160;<span class="comment"> * Redistribution and use in source and binary forms, with or without</span></div>
<div class="line"><a name="l00011"></a><span class="lineno">   11</span>&#160;<span class="comment"> * modification, are permitted provided that the following conditions</span></div>
<div class="line"><a name="l00012"></a><span class="lineno">   12</span>&#160;<span class="comment"> * are met:</span></div>
<div class="line"><a name="l00013"></a><span class="lineno">   13</span>&#160;<span class="comment"> *</span></div>
<div class="line"><a name="l00014"></a><span class="lineno">   14</span>&#160;<span class="comment"> *    Redistributions of source code must retain the above copyright</span></div>
<div class="line"><a name="l00015"></a><span class="lineno">   15</span>&#160;<span class="comment"> *    notice, this list of conditions and the following disclaimer.</span></div>
<div class="line"><a name="l00016"></a><span class="lineno">   16</span>&#160;<span class="comment"> *</span></div>
<div class="line"><a name="l00017"></a><span class="lineno">   17</span>&#160;<span class="comment"> *    Redistributions in binary form must reproduce the above copyright</span></div>
<div class="line"><a name="l00018"></a><span class="lineno">   18</span>&#160;<span class="comment"> *    notice, this list of conditions and the following disclaimer in the</span></div>
<div class="line"><a name="l00019"></a><span class="lineno">   19</span>&#160;<span class="comment"> *    documentation and/or other materials provided with the</span></div>
<div class="line"><a name="l00020"></a><span class="lineno">   20</span>&#160;<span class="comment"> *    distribution.</span></div>
<div class="line"><a name="l00021"></a><span class="lineno">   21</span>&#160;<span class="comment"> *</span></div>
<div class="line"><a name="l00022"></a><span class="lineno">   22</span>&#160;<span class="comment"> *    Neither the name of Texas Instruments Incorporated nor the names of</span></div>
<div class="line"><a name="l00023"></a><span class="lineno">   23</span>&#160;<span class="comment"> *    its contributors may be used to endorse or promote products derived</span></div>
<div class="line"><a name="l00024"></a><span class="lineno">   24</span>&#160;<span class="comment"> *    from this software without specific prior written permission.</span></div>
<div class="line"><a name="l00025"></a><span class="lineno">   25</span>&#160;<span class="comment"> *</span></div>
<div class="line"><a name="l00026"></a><span class="lineno">   26</span>&#160;<span class="comment"> * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS</span></div>
<div class="line"><a name="l00027"></a><span class="lineno">   27</span>&#160;<span class="comment"> * &quot;AS IS&quot; AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT</span></div>
<div class="line"><a name="l00028"></a><span class="lineno">   28</span>&#160;<span class="comment"> * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR</span></div>
<div class="line"><a name="l00029"></a><span class="lineno">   29</span>&#160;<span class="comment"> * A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT</span></div>
<div class="line"><a name="l00030"></a><span class="lineno">   30</span>&#160;<span class="comment"> * OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,</span></div>
<div class="line"><a name="l00031"></a><span class="lineno">   31</span>&#160;<span class="comment"> * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT</span></div>
<div class="line"><a name="l00032"></a><span class="lineno">   32</span>&#160;<span class="comment"> * LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,</span></div>
<div class="line"><a name="l00033"></a><span class="lineno">   33</span>&#160;<span class="comment"> * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY</span></div>
<div class="line"><a name="l00034"></a><span class="lineno">   34</span>&#160;<span class="comment"> * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT</span></div>
<div class="line"><a name="l00035"></a><span class="lineno">   35</span>&#160;<span class="comment"> * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE</span></div>
<div class="line"><a name="l00036"></a><span class="lineno">   36</span>&#160;<span class="comment"> * OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.</span></div>
<div class="line"><a name="l00037"></a><span class="lineno">   37</span>&#160;<span class="comment"> *</span></div>
<div class="line"><a name="l00038"></a><span class="lineno">   38</span>&#160;<span class="comment"> ******************************************************************************/</span></div>
<div class="line"><a name="l00039"></a><span class="lineno">   39</span>&#160;</div>
<div class="line"><a name="l00040"></a><span class="lineno">   40</span>&#160;<span class="comment">/******************************************************************************</span></div>
<div class="line"><a name="l00041"></a><span class="lineno">   41</span>&#160;<span class="comment"> *</span></div>
<div class="line"><a name="l00042"></a><span class="lineno">   42</span>&#160;<span class="comment"> * INCLUDES</span></div>
<div class="line"><a name="l00043"></a><span class="lineno">   43</span>&#160;<span class="comment"> *</span></div>
<div class="line"><a name="l00044"></a><span class="lineno">   44</span>&#160;<span class="comment"> ******************************************************************************/</span></div>
<div class="line"><a name="l00045"></a><span class="lineno">   45</span>&#160;<span class="preprocessor">#include &quot;<a class="code" href="tiglMutationMessage_8hpp.html">tiglMutationMessage.hpp</a>&quot;</span></div>
<div class="line"><a name="l00046"></a><span class="lineno">   46</span>&#160;</div>
<div class="line"><a name="l00047"></a><span class="lineno">   47</span>&#160;<span class="comment">/*****************************************************************************/</span></div>
<div class="line"><a name="l00055"></a><span class="lineno">   55</span>&#160;<span class="comment">/*****************************************************************************/</span></div>
<div class="line"><a name="l00056"></a><span class="lineno">   56</span>&#160;<span class="keyword">template</span>&lt;<span class="keyword">typename</span> SUBGRAPH_CLASS&gt;</div>
<div class="line"><a name="l00057"></a><span class="lineno"><a class="line" href="classTIGLMutationManager.html">   57</a></span>&#160;<span class="keyword">class </span><a class="code" href="classTIGLMutationManager.html">TIGLMutationManager</a></div>
<div class="line"><a name="l00058"></a><span class="lineno">   58</span>&#160;{</div>
<div class="line"><a name="l00059"></a><span class="lineno">   59</span>&#160;   <span class="comment">/******************************************************************************</span></div>
<div class="line"><a name="l00060"></a><span class="lineno">   60</span>&#160;<span class="comment">    *</span></div>
<div class="line"><a name="l00061"></a><span class="lineno">   61</span>&#160;<span class="comment">    * type definitions</span></div>
<div class="line"><a name="l00062"></a><span class="lineno">   62</span>&#160;<span class="comment">    *</span></div>
<div class="line"><a name="l00063"></a><span class="lineno">   63</span>&#160;<span class="comment">    ******************************************************************************/</span></div>
<div class="line"><a name="l00064"></a><span class="lineno">   64</span>&#160;<span class="keyword">public</span>:</div>
<div class="line"><a name="l00065"></a><span class="lineno">   65</span>&#160;   <span class="keyword">typedef</span> SUBGRAPH_CLASS DATA_CONTAINER_TYPE;</div>
<div class="line"><a name="l00066"></a><span class="lineno">   66</span>&#160;   <span class="keyword">typedef</span> <span class="keyword">typename</span> SUBGRAPH_CLASS::ID_TYPE ID_TYPE;</div>
<div class="line"><a name="l00067"></a><span class="lineno">   67</span>&#160;   <span class="keyword">typedef</span> <span class="keyword">typename</span> SUBGRAPH_CLASS::VERTEX_ITERATOR VERTEX_ITERATOR;</div>
<div class="line"><a name="l00068"></a><span class="lineno">   68</span>&#160;   <span class="keyword">typedef</span> <span class="keyword">typename</span> SUBGRAPH_CLASS::VERTEX_TYPE VERTEX_TYPE;</div>
<div class="line"><a name="l00069"></a><span class="lineno">   69</span>&#160;   <span class="keyword">typedef</span> <span class="keyword">typename</span> VERTEX_TYPE::EDGE_TYPE EDGE_TYPE;</div>
<div class="line"><a name="l00070"></a><span class="lineno">   70</span>&#160;   <span class="keyword">typedef</span> <span class="keyword">typename</span> VERTEX_TYPE::EDGE_ITERATOR EDGE_ITERATOR;</div>
<div class="line"><a name="l00071"></a><span class="lineno">   71</span>&#160;</div>
<div class="line"><a name="l00072"></a><span class="lineno">   72</span>&#160;   <span class="comment">/******************************************************************************</span></div>
<div class="line"><a name="l00073"></a><span class="lineno">   73</span>&#160;<span class="comment">    *</span></div>
<div class="line"><a name="l00074"></a><span class="lineno">   74</span>&#160;<span class="comment">    * constructor/destructor</span></div>
<div class="line"><a name="l00075"></a><span class="lineno">   75</span>&#160;<span class="comment">    *</span></div>
<div class="line"><a name="l00076"></a><span class="lineno">   76</span>&#160;<span class="comment">    ******************************************************************************/</span></div>
<div class="line"><a name="l00077"></a><span class="lineno">   77</span>&#160;<span class="keyword">public</span>:</div>
<div class="line"><a name="l00078"></a><span class="lineno">   78</span>&#160;   <a class="code" href="classTIGLMutationManager.html">TIGLMutationManager</a>(DATA_CONTAINER_TYPE *pManager)</div>
<div class="line"><a name="l00079"></a><span class="lineno">   79</span>&#160;   {</div>
<div class="line"><a name="l00080"></a><span class="lineno">   80</span>&#160;      <a class="code" href="classTIGLMutationManager.html#a6ddb2bb4d75734599ef7a39fd0291b8e">dataManager</a> = pManager;</div>
<div class="line"><a name="l00081"></a><span class="lineno">   81</span>&#160;   }</div>
<div class="line"><a name="l00082"></a><span class="lineno">   82</span>&#160;   ~<a class="code" href="classTIGLMutationManager.html">TIGLMutationManager</a>()</div>
<div class="line"><a name="l00083"></a><span class="lineno">   83</span>&#160;   {</div>
<div class="line"><a name="l00084"></a><span class="lineno">   84</span>&#160;   }</div>
<div class="line"><a name="l00085"></a><span class="lineno">   85</span>&#160;</div>
<div class="line"><a name="l00086"></a><span class="lineno">   86</span>&#160;   <span class="comment">/******************************************************************************</span></div>
<div class="line"><a name="l00087"></a><span class="lineno">   87</span>&#160;<span class="comment">    *</span></div>
<div class="line"><a name="l00088"></a><span class="lineno">   88</span>&#160;<span class="comment">    * attributes</span></div>
<div class="line"><a name="l00089"></a><span class="lineno">   89</span>&#160;<span class="comment">    *</span></div>
<div class="line"><a name="l00090"></a><span class="lineno">   90</span>&#160;<span class="comment">    ******************************************************************************/</span></div>
<div class="line"><a name="l00091"></a><span class="lineno">   91</span>&#160;<span class="keyword">protected</span>:</div>
<div class="line"><a name="l00093"></a><span class="lineno"><a class="line" href="classTIGLMutationManager.html#a6ddb2bb4d75734599ef7a39fd0291b8e">   93</a></span>&#160;   DATA_CONTAINER_TYPE *<a class="code" href="classTIGLMutationManager.html#a6ddb2bb4d75734599ef7a39fd0291b8e">dataManager</a>;</div>
<div class="line"><a name="l00094"></a><span class="lineno">   94</span>&#160;</div>
<div class="line"><a name="l00095"></a><span class="lineno">   95</span>&#160;   <span class="comment">/******************************************************************************</span></div>
<div class="line"><a name="l00096"></a><span class="lineno">   96</span>&#160;<span class="comment">    *</span></div>
<div class="line"><a name="l00097"></a><span class="lineno">   97</span>&#160;<span class="comment">    * methods</span></div>
<div class="line"><a name="l00098"></a><span class="lineno">   98</span>&#160;<span class="comment">    *</span></div>
<div class="line"><a name="l00099"></a><span class="lineno">   99</span>&#160;<span class="comment">    ******************************************************************************/</span></div>
<div class="line"><a name="l00100"></a><span class="lineno">  100</span>&#160;<span class="keyword">public</span>:</div>
<div class="line"><a name="l00101"></a><span class="lineno">  101</span>&#160;   <span class="comment">/*****************************************************************************/</span></div>
<div class="line"><a name="l00105"></a><span class="lineno">  105</span>&#160;   <span class="comment">/*****************************************************************************/</span></div>
<div class="line"><a name="l00106"></a><span class="lineno"><a class="line" href="classTIGLMutationManager.html#ac7ec277f489a4961de1bba26ae72679a">  106</a></span>&#160;   <span class="keywordtype">void</span> <a class="code" href="classTIGLMutationManager.html#ac7ec277f489a4961de1bba26ae72679a">processAllMutationMessages</a>()</div>
<div class="line"><a name="l00107"></a><span class="lineno">  107</span>&#160;   {</div>
<div class="line"><a name="l00108"></a><span class="lineno">  108</span>&#160;      <span class="keywordtype">int</span> numAllocThreads = <a class="code" href="classTIGLMutationManager.html#a6ddb2bb4d75734599ef7a39fd0291b8e">dataManager</a>-&gt;getNumAllocThreads();</div>
<div class="line"><a name="l00109"></a><span class="lineno">  109</span>&#160;<span class="preprocessor">#if defined(_MPI)</span></div>
<div class="line"><a name="l00110"></a><span class="lineno">  110</span>&#160;      numAllocThreads--;</div>
<div class="line"><a name="l00111"></a><span class="lineno">  111</span>&#160;<span class="preprocessor">#endif</span></div>
<div class="line"><a name="l00112"></a><span class="lineno">  112</span>&#160;      OMP(<span class="stringliteral">&quot;omp parallel for&quot;</span>)</div>
<div class="line"><a name="l00113"></a><span class="lineno">  113</span>&#160;      <span class="keywordflow">for</span> (<span class="keywordtype">int</span> thread = 0; thread &lt; numAllocThreads; thread++)</div>
<div class="line"><a name="l00114"></a><span class="lineno">  114</span>&#160;         <a class="code" href="classTIGLMutationManager.html#a06acf82a5e7b4c8d1277bd2b140a1298">processMutationMessages</a>(thread);</div>
<div class="line"><a name="l00115"></a><span class="lineno">  115</span>&#160;   }</div>
<div class="line"><a name="l00116"></a><span class="lineno">  116</span>&#160;</div>
<div class="line"><a name="l00117"></a><span class="lineno">  117</span>&#160;   <span class="comment">/*****************************************************************************/</span></div>
<div class="line"><a name="l00123"></a><span class="lineno">  123</span>&#160;   <span class="comment">/*****************************************************************************/</span></div>
<div class="line"><a name="l00124"></a><span class="lineno"><a class="line" href="classTIGLMutationManager.html#a06acf82a5e7b4c8d1277bd2b140a1298">  124</a></span>&#160;   <span class="keywordtype">void</span> <a class="code" href="classTIGLMutationManager.html#a06acf82a5e7b4c8d1277bd2b140a1298">processMutationMessages</a>(<span class="keywordtype">int</span> thread = 0)</div>
<div class="line"><a name="l00125"></a><span class="lineno">  125</span>&#160;   {</div>
<div class="line"><a name="l00126"></a><span class="lineno">  126</span>&#160;      vector&lt;TIGLMutationMessage&gt; *messBuf = <a class="code" href="classTIGLMutationManager.html#a6ddb2bb4d75734599ef7a39fd0291b8e">dataManager</a>-&gt;getInMutationMessageBuf(thread);</div>
<div class="line"><a name="l00127"></a><span class="lineno">  127</span>&#160;      <span class="keywordflow">if</span> (messBuf-&gt;empty())</div>
<div class="line"><a name="l00128"></a><span class="lineno">  128</span>&#160;         <span class="keywordflow">return</span>;</div>
<div class="line"><a name="l00129"></a><span class="lineno">  129</span>&#160;      vector&lt;TIGLMutationMessage&gt;::iterator itMessage;</div>
<div class="line"><a name="l00130"></a><span class="lineno">  130</span>&#160;      vector&lt;TIGLMutationMessage&gt;::iterator itBegin = messBuf-&gt;begin();</div>
<div class="line"><a name="l00131"></a><span class="lineno">  131</span>&#160;</div>
<div class="line"><a name="l00134"></a><span class="lineno">  134</span>&#160;      <span class="keywordflow">for</span> (itMessage = itBegin; itMessage != messBuf-&gt;end(); ++itMessage)</div>
<div class="line"><a name="l00135"></a><span class="lineno">  135</span>&#160;      {</div>
<div class="line"><a name="l00137"></a><span class="lineno">  137</span>&#160;         MUTATION_MESSAGE_CODE messCode = itMessage-&gt;getMessageCode();</div>
<div class="line"><a name="l00138"></a><span class="lineno">  138</span>&#160;</div>
<div class="line"><a name="l00140"></a><span class="lineno">  140</span>&#160;         <span class="keywordflow">switch</span> (messCode) {</div>
<div class="line"><a name="l00141"></a><span class="lineno">  141</span>&#160;            <span class="keywordflow">case</span> ADD_VERTEX: {</div>
<div class="line"><a name="l00142"></a><span class="lineno">  142</span>&#160;               VERTEX_TYPE newVertex(0);   <span class="comment">// uinitialized vertex</span></div>
<div class="line"><a name="l00143"></a><span class="lineno">  143</span>&#160;               <span class="keywordflow">if</span> (itMessage-&gt;readVertexMessage(&amp;newVertex) == <span class="keyword">false</span>)</div>
<div class="line"><a name="l00144"></a><span class="lineno">  144</span>&#160;               {</div>
<div class="line"><a name="l00145"></a><span class="lineno">  145</span>&#160;                  OMP(<span class="stringliteral">&quot;omp critical (PRINT)&quot;</span>)</div>
<div class="line"><a name="l00146"></a><span class="lineno">  146</span>&#160;                  cout &lt;&lt; <span class="stringliteral">&quot;!!!! ERROR reading ADD_VERTEX message &quot;</span> &lt;&lt; endl;</div>
<div class="line"><a name="l00147"></a><span class="lineno">  147</span>&#160;                  <span class="keywordflow">continue</span>;</div>
<div class="line"><a name="l00148"></a><span class="lineno">  148</span>&#160;               }</div>
<div class="line"><a name="l00149"></a><span class="lineno">  149</span>&#160;</div>
<div class="line"><a name="l00150"></a><span class="lineno">  150</span>&#160;               <a class="code" href="classTIGLMutationManager.html#a6ddb2bb4d75734599ef7a39fd0291b8e">dataManager</a>-&gt;addVertex(newVertex);</div>
<div class="line"><a name="l00151"></a><span class="lineno">  151</span>&#160;               <span class="keywordflow">break</span>;</div>
<div class="line"><a name="l00152"></a><span class="lineno">  152</span>&#160;            }</div>
<div class="line"><a name="l00153"></a><span class="lineno">  153</span>&#160;            <span class="keywordflow">case</span> ADD_EMPTY_VERTEX: {</div>
<div class="line"><a name="l00154"></a><span class="lineno">  154</span>&#160;               ID_TYPE id;</div>
<div class="line"><a name="l00155"></a><span class="lineno">  155</span>&#160;               <span class="keywordflow">if</span> (itMessage-&gt;readSimpleVertexMessage(&amp;<span class="keywordtype">id</span>) == <span class="keyword">false</span>)</div>
<div class="line"><a name="l00156"></a><span class="lineno">  156</span>&#160;               {</div>
<div class="line"><a name="l00157"></a><span class="lineno">  157</span>&#160;                  cout &lt;&lt; <span class="stringliteral">&quot;!!!! ERROR reading ADD_EMPTY_VERTEX message &quot;</span> &lt;&lt; endl;</div>
<div class="line"><a name="l00158"></a><span class="lineno">  158</span>&#160;                  <span class="keywordflow">continue</span>;</div>
<div class="line"><a name="l00159"></a><span class="lineno">  159</span>&#160;               }</div>
<div class="line"><a name="l00160"></a><span class="lineno">  160</span>&#160;</div>
<div class="line"><a name="l00161"></a><span class="lineno">  161</span>&#160;               <a class="code" href="classTIGLMutationManager.html#a6ddb2bb4d75734599ef7a39fd0291b8e">dataManager</a>-&gt;addVertex(<span class="keywordtype">id</span>);</div>
<div class="line"><a name="l00162"></a><span class="lineno">  162</span>&#160;               <span class="keywordflow">break</span>;</div>
<div class="line"><a name="l00163"></a><span class="lineno">  163</span>&#160;            }</div>
<div class="line"><a name="l00164"></a><span class="lineno">  164</span>&#160;            <span class="keywordflow">case</span> REMOVE_VERTEX: {</div>
<div class="line"><a name="l00165"></a><span class="lineno">  165</span>&#160;               ID_TYPE id;</div>
<div class="line"><a name="l00166"></a><span class="lineno">  166</span>&#160;               <span class="keywordflow">if</span> (itMessage-&gt;readSimpleVertexMessage(&amp;<span class="keywordtype">id</span>) == <span class="keyword">false</span>)</div>
<div class="line"><a name="l00167"></a><span class="lineno">  167</span>&#160;               {</div>
<div class="line"><a name="l00168"></a><span class="lineno">  168</span>&#160;                  cout &lt;&lt; <span class="stringliteral">&quot;!!!! ERROR reading REMOVE_VERTEX message &quot;</span> &lt;&lt; endl;</div>
<div class="line"><a name="l00169"></a><span class="lineno">  169</span>&#160;                  <span class="keywordflow">continue</span>;</div>
<div class="line"><a name="l00170"></a><span class="lineno">  170</span>&#160;               }</div>
<div class="line"><a name="l00171"></a><span class="lineno">  171</span>&#160;               VERTEX_ITERATOR itv;</div>
<div class="line"><a name="l00172"></a><span class="lineno">  172</span>&#160;               <span class="keywordflow">if</span> (<a class="code" href="classTIGLMutationManager.html#a6ddb2bb4d75734599ef7a39fd0291b8e">dataManager</a>-&gt;getVertex(<span class="keywordtype">id</span>, &amp;itv) == <span class="keyword">false</span>)</div>
<div class="line"><a name="l00173"></a><span class="lineno">  173</span>&#160;                  <span class="keywordflow">continue</span>;</div>
<div class="line"><a name="l00174"></a><span class="lineno">  174</span>&#160;               <span class="comment">// removing all edges of this vertex</span></div>
<div class="line"><a name="l00175"></a><span class="lineno">  175</span>&#160;               EDGE_ITERATOR itEdge;</div>
<div class="line"><a name="l00176"></a><span class="lineno">  176</span>&#160;               <span class="keywordflow">if</span> (itv-&gt;getNumOutEdges())</div>
<div class="line"><a name="l00177"></a><span class="lineno">  177</span>&#160;               {</div>
<div class="line"><a name="l00178"></a><span class="lineno">  178</span>&#160;                  <span class="keywordflow">if</span> (<a class="code" href="classTIGLMutationManager.html#a6ddb2bb4d75734599ef7a39fd0291b8e">dataManager</a>-&gt;isDirected() == <span class="keyword">false</span>)</div>
<div class="line"><a name="l00179"></a><span class="lineno">  179</span>&#160;                  {   <span class="comment">// undirected graph</span></div>
<div class="line"><a name="l00180"></a><span class="lineno">  180</span>&#160;                     <span class="keywordflow">for</span> (itEdge = itv-&gt;getBeginOutEdgeIterator(); itEdge != itv-&gt;getEndOutEdgeIterator(); ++itEdge)</div>
<div class="line"><a name="l00181"></a><span class="lineno">  181</span>&#160;                     {</div>
<div class="line"><a name="l00182"></a><span class="lineno">  182</span>&#160;                        ID_TYPE targetVertex = itEdge-&gt;getNbr();</div>
<div class="line"><a name="l00183"></a><span class="lineno">  183</span>&#160;                        <span class="keywordflow">if</span> (<a class="code" href="classTIGLMutationManager.html#a6ddb2bb4d75734599ef7a39fd0291b8e">dataManager</a>-&gt;exist(targetVertex))</div>
<div class="line"><a name="l00184"></a><span class="lineno">  184</span>&#160;                        {   <span class="comment">// removing the corresponding output edge</span></div>
<div class="line"><a name="l00185"></a><span class="lineno">  185</span>&#160;                           <a class="code" href="classTIGLMutationManager.html#a6ddb2bb4d75734599ef7a39fd0291b8e">dataManager</a>-&gt;removeOutEdge(targetVertex, <span class="keywordtype">id</span>);</div>
<div class="line"><a name="l00186"></a><span class="lineno">  186</span>&#160;                        }</div>
<div class="line"><a name="l00187"></a><span class="lineno">  187</span>&#160;<span class="preprocessor">#if defined(_MPI)</span></div>
<div class="line"><a name="l00188"></a><span class="lineno">  188</span>&#160;                        <span class="keywordflow">else</span></div>
<div class="line"><a name="l00189"></a><span class="lineno">  189</span>&#160;                        {</div>
<div class="line"><a name="l00190"></a><span class="lineno">  190</span>&#160;                           <a class="code" href="classTIGLMutationMessage.html">TIGLMutationMessage</a> mess(UNKNOWN_DEV);   <span class="comment">//mess(REMOVE_OUT_EDGE, UNKNOWN_DEV, &amp;id, &amp;targetVertex);</span></div>
<div class="line"><a name="l00191"></a><span class="lineno">  191</span>&#160;                           mess.<a class="code" href="classTIGLMutationMessage.html#a183239c71e1e921ce501e10376baa0d5">writeSimpleEdgeMessage</a>(REMOVE_OUT_EDGE, &amp;<span class="keywordtype">id</span>, &amp;targetVertex);</div>
<div class="line"><a name="l00192"></a><span class="lineno">  192</span>&#160;                           <a class="code" href="classTIGLMutationManager.html#a6ddb2bb4d75734599ef7a39fd0291b8e">dataManager</a>-&gt;pushExternalMutationMessage(mess, thread);</div>
<div class="line"><a name="l00193"></a><span class="lineno">  193</span>&#160;                        }</div>
<div class="line"><a name="l00194"></a><span class="lineno">  194</span>&#160;<span class="preprocessor">#endif</span></div>
<div class="line"><a name="l00195"></a><span class="lineno">  195</span>&#160;                     }</div>
<div class="line"><a name="l00196"></a><span class="lineno">  196</span>&#160;                  }</div>
<div class="line"><a name="l00197"></a><span class="lineno">  197</span>&#160;               }</div>
<div class="line"><a name="l00198"></a><span class="lineno">  198</span>&#160;               <span class="keywordflow">else</span> <span class="keywordflow">if</span> (itv-&gt;isBiVertex() == <span class="keyword">true</span> &amp;&amp; <a class="code" href="classTIGLMutationManager.html#a6ddb2bb4d75734599ef7a39fd0291b8e">dataManager</a>-&gt;isDirected() == <span class="keyword">true</span>)</div>
<div class="line"><a name="l00199"></a><span class="lineno">  199</span>&#160;               {   <span class="comment">// directed and bivertex</span></div>
<div class="line"><a name="l00200"></a><span class="lineno">  200</span>&#160;                   <span class="comment">// removing output edges (which are input edges to target vertics)</span></div>
<div class="line"><a name="l00201"></a><span class="lineno">  201</span>&#160;                  <span class="keywordflow">for</span> (itEdge = itv-&gt;getBeginOutEdgeIterator(); itEdge != itv-&gt;getEndOutEdgeIterator(); ++itEdge)</div>
<div class="line"><a name="l00202"></a><span class="lineno">  202</span>&#160;                  {</div>
<div class="line"><a name="l00203"></a><span class="lineno">  203</span>&#160;                     ID_TYPE targetVertex = itEdge-&gt;getNbr();</div>
<div class="line"><a name="l00204"></a><span class="lineno">  204</span>&#160;                     <span class="keywordflow">if</span> (<a class="code" href="classTIGLMutationManager.html#a6ddb2bb4d75734599ef7a39fd0291b8e">dataManager</a>-&gt;exist(targetVertex))</div>
<div class="line"><a name="l00205"></a><span class="lineno">  205</span>&#160;                     {</div>
<div class="line"><a name="l00206"></a><span class="lineno">  206</span>&#160;                        <a class="code" href="classTIGLMutationManager.html#a6ddb2bb4d75734599ef7a39fd0291b8e">dataManager</a>-&gt;removeInEdge(<span class="keywordtype">id</span>, targetVertex);</div>
<div class="line"><a name="l00207"></a><span class="lineno">  207</span>&#160;                     }</div>
<div class="line"><a name="l00208"></a><span class="lineno">  208</span>&#160;<span class="preprocessor">#if defined(_MPI)</span></div>
<div class="line"><a name="l00209"></a><span class="lineno">  209</span>&#160;                     <span class="keywordflow">else</span></div>
<div class="line"><a name="l00210"></a><span class="lineno">  210</span>&#160;                     {</div>
<div class="line"><a name="l00211"></a><span class="lineno">  211</span>&#160;                        <a class="code" href="classTIGLMutationMessage.html">TIGLMutationMessage</a> mess(UNKNOWN_DEV);                  <span class="comment">//</span></div>
<div class="line"><a name="l00212"></a><span class="lineno">  212</span>&#160;                        mess.<a class="code" href="classTIGLMutationMessage.html#a183239c71e1e921ce501e10376baa0d5">writeSimpleEdgeMessage</a>(REMOVE_IN_EDGE, &amp;<span class="keywordtype">id</span>, &amp;targetVertex);</div>
<div class="line"><a name="l00213"></a><span class="lineno">  213</span>&#160;                        <a class="code" href="classTIGLMutationManager.html#a6ddb2bb4d75734599ef7a39fd0291b8e">dataManager</a>-&gt;pushExternalMutationMessage(mess, thread);</div>
<div class="line"><a name="l00214"></a><span class="lineno">  214</span>&#160;                     }</div>
<div class="line"><a name="l00215"></a><span class="lineno">  215</span>&#160;<span class="preprocessor">#endif</span></div>
<div class="line"><a name="l00216"></a><span class="lineno">  216</span>&#160;                  }</div>
<div class="line"><a name="l00217"></a><span class="lineno">  217</span>&#160;                  <span class="comment">// now removing input edges (which are output edges to target vertices)</span></div>
<div class="line"><a name="l00218"></a><span class="lineno">  218</span>&#160;                  <span class="keywordflow">for</span> (itEdge = itv-&gt;getBeginInEdgeIterator(); itEdge != itv-&gt;getEndInEdgeIterator(); ++itEdge)</div>
<div class="line"><a name="l00219"></a><span class="lineno">  219</span>&#160;                  {</div>
<div class="line"><a name="l00220"></a><span class="lineno">  220</span>&#160;                     ID_TYPE srcVertex = itEdge-&gt;getNbr();</div>
<div class="line"><a name="l00221"></a><span class="lineno">  221</span>&#160;                     <span class="keywordflow">if</span> (<a class="code" href="classTIGLMutationManager.html#a6ddb2bb4d75734599ef7a39fd0291b8e">dataManager</a>-&gt;exist(srcVertex))</div>
<div class="line"><a name="l00222"></a><span class="lineno">  222</span>&#160;                     {</div>
<div class="line"><a name="l00223"></a><span class="lineno">  223</span>&#160;                        <a class="code" href="classTIGLMutationManager.html#a6ddb2bb4d75734599ef7a39fd0291b8e">dataManager</a>-&gt;removeOutEdge(srcVertex, <span class="keywordtype">id</span>);</div>
<div class="line"><a name="l00224"></a><span class="lineno">  224</span>&#160;                     }</div>
<div class="line"><a name="l00225"></a><span class="lineno">  225</span>&#160;<span class="preprocessor">#if defined(_MPI)</span></div>
<div class="line"><a name="l00226"></a><span class="lineno">  226</span>&#160;                     <span class="keywordflow">else</span></div>
<div class="line"><a name="l00227"></a><span class="lineno">  227</span>&#160;                     {</div>
<div class="line"><a name="l00228"></a><span class="lineno">  228</span>&#160;                        <a class="code" href="classTIGLMutationMessage.html">TIGLMutationMessage</a> mess(UNKNOWN_DEV);                  <span class="comment">//</span></div>
<div class="line"><a name="l00229"></a><span class="lineno">  229</span>&#160;                        mess.<a class="code" href="classTIGLMutationMessage.html#a183239c71e1e921ce501e10376baa0d5">writeSimpleEdgeMessage</a>(REMOVE_OUT_EDGE, &amp;<span class="keywordtype">id</span>, &amp;srcVertex);</div>
<div class="line"><a name="l00230"></a><span class="lineno">  230</span>&#160;                        <a class="code" href="classTIGLMutationManager.html#a6ddb2bb4d75734599ef7a39fd0291b8e">dataManager</a>-&gt;pushExternalMutationMessage(mess, thread);</div>
<div class="line"><a name="l00231"></a><span class="lineno">  231</span>&#160;                     }</div>
<div class="line"><a name="l00232"></a><span class="lineno">  232</span>&#160;<span class="preprocessor">#endif</span></div>
<div class="line"><a name="l00233"></a><span class="lineno">  233</span>&#160;                  }</div>
<div class="line"><a name="l00234"></a><span class="lineno">  234</span>&#160;               }</div>
<div class="line"><a name="l00235"></a><span class="lineno">  235</span>&#160;               <span class="comment">// there is a third hole case where it is directed and not bivertex; which cannot be handled here</span></div>
<div class="line"><a name="l00236"></a><span class="lineno">  236</span>&#160;               <a class="code" href="classTIGLMutationManager.html#a6ddb2bb4d75734599ef7a39fd0291b8e">dataManager</a>-&gt;removeVertex(<span class="keywordtype">id</span>);</div>
<div class="line"><a name="l00237"></a><span class="lineno">  237</span>&#160;               <span class="keywordflow">break</span>;</div>
<div class="line"><a name="l00238"></a><span class="lineno">  238</span>&#160;            }</div>
<div class="line"><a name="l00239"></a><span class="lineno">  239</span>&#160;            <span class="keywordflow">case</span> ADD_OUT_EDGE:</div>
<div class="line"><a name="l00240"></a><span class="lineno">  240</span>&#160;            <span class="keywordflow">case</span> ADD_IN_EDGE: {</div>
<div class="line"><a name="l00241"></a><span class="lineno">  241</span>&#160;               EDGE_TYPE edge(0);</div>
<div class="line"><a name="l00242"></a><span class="lineno">  242</span>&#160;               ID_TYPE vertex;</div>
<div class="line"><a name="l00243"></a><span class="lineno">  243</span>&#160;               <span class="keywordflow">if</span> (itMessage-&gt;readEdgeMessage(&amp;edge, &amp;vertex) == <span class="keyword">false</span>)</div>
<div class="line"><a name="l00244"></a><span class="lineno">  244</span>&#160;               {</div>
<div class="line"><a name="l00245"></a><span class="lineno">  245</span>&#160;                  OMP(<span class="stringliteral">&quot;omp critical(PRINT)&quot;</span>)</div>
<div class="line"><a name="l00246"></a><span class="lineno">  246</span>&#160;                  cout &lt;&lt; <span class="stringliteral">&quot;!!!!!!!!! ERROR in thread &quot;</span> &lt;&lt; thread &lt;&lt; <span class="stringliteral">&quot; reading edge message &quot;</span> &lt;&lt; endl;</div>
<div class="line"><a name="l00247"></a><span class="lineno">  247</span>&#160;                  <span class="keywordflow">continue</span>;</div>
<div class="line"><a name="l00248"></a><span class="lineno">  248</span>&#160;               }</div>
<div class="line"><a name="l00249"></a><span class="lineno">  249</span>&#160;               <span class="keywordflow">if</span> (<a class="code" href="classTIGLMutationManager.html#a6ddb2bb4d75734599ef7a39fd0291b8e">dataManager</a>-&gt;exist(vertex) == <span class="keyword">false</span>)</div>
<div class="line"><a name="l00250"></a><span class="lineno">  250</span>&#160;               {</div>
<div class="line"><a name="l00251"></a><span class="lineno">  251</span>&#160;                  OMP(<span class="stringliteral">&quot;omp critical(PRINT)&quot;</span>)</div>
<div class="line"><a name="l00252"></a><span class="lineno">  252</span>&#160;                  cout &lt;&lt; <span class="stringliteral">&quot;!!!!!!!!! ERROR in thread &quot;</span> &lt;&lt; thread &lt;&lt; <span class="stringliteral">&quot;: vertex &quot;</span> &lt;&lt; vertex &lt;&lt; <span class="stringliteral">&quot; does not exist&quot;</span> &lt;&lt; endl;</div>
<div class="line"><a name="l00253"></a><span class="lineno">  253</span>&#160;                  <span class="keywordflow">continue</span>;</div>
<div class="line"><a name="l00254"></a><span class="lineno">  254</span>&#160;               }</div>
<div class="line"><a name="l00255"></a><span class="lineno">  255</span>&#160;               <span class="keywordflow">if</span> (messCode == ADD_OUT_EDGE)</div>
<div class="line"><a name="l00256"></a><span class="lineno">  256</span>&#160;               {</div>
<div class="line"><a name="l00257"></a><span class="lineno">  257</span>&#160;                  <span class="keywordflow">if</span> (<a class="code" href="classTIGLMutationManager.html#a6ddb2bb4d75734599ef7a39fd0291b8e">dataManager</a>-&gt;addOutEdge(vertex, edge) == <span class="keyword">false</span>)</div>
<div class="line"><a name="l00258"></a><span class="lineno">  258</span>&#160;                  {</div>
<div class="line"><a name="l00259"></a><span class="lineno">  259</span>&#160;                     <span class="keywordflow">continue</span>;</div>
<div class="line"><a name="l00260"></a><span class="lineno">  260</span>&#160;                  }</div>
<div class="line"><a name="l00261"></a><span class="lineno">  261</span>&#160;               }</div>
<div class="line"><a name="l00262"></a><span class="lineno">  262</span>&#160;               <span class="keywordflow">else</span></div>
<div class="line"><a name="l00263"></a><span class="lineno">  263</span>&#160;               {</div>
<div class="line"><a name="l00264"></a><span class="lineno">  264</span>&#160;                  <a class="code" href="classTIGLMutationManager.html#a6ddb2bb4d75734599ef7a39fd0291b8e">dataManager</a>-&gt;addInEdge(vertex, edge);</div>
<div class="line"><a name="l00265"></a><span class="lineno">  265</span>&#160;               }</div>
<div class="line"><a name="l00266"></a><span class="lineno">  266</span>&#160;               <span class="keywordflow">break</span>;</div>
<div class="line"><a name="l00267"></a><span class="lineno">  267</span>&#160;            }</div>
<div class="line"><a name="l00268"></a><span class="lineno">  268</span>&#160;            <span class="keywordflow">case</span> REMOVE_OUT_EDGE:</div>
<div class="line"><a name="l00269"></a><span class="lineno">  269</span>&#160;            <span class="keywordflow">case</span> REMOVE_IN_EDGE:</div>
<div class="line"><a name="l00270"></a><span class="lineno">  270</span>&#160;               ID_TYPE src, target;</div>
<div class="line"><a name="l00271"></a><span class="lineno">  271</span>&#160;               <span class="keywordflow">if</span> (itMessage-&gt;readSimpleEdgeMessage(&amp;target, &amp;src) == <span class="keyword">false</span>)</div>
<div class="line"><a name="l00272"></a><span class="lineno">  272</span>&#160;               {</div>
<div class="line"><a name="l00273"></a><span class="lineno">  273</span>&#160;                  cout &lt;&lt; <span class="stringliteral">&quot;!!!! ERROR reading REMOVE_EDGE message &quot;</span> &lt;&lt; endl;</div>
<div class="line"><a name="l00274"></a><span class="lineno">  274</span>&#160;                  <span class="keywordflow">continue</span>;</div>
<div class="line"><a name="l00275"></a><span class="lineno">  275</span>&#160;               }</div>
<div class="line"><a name="l00276"></a><span class="lineno">  276</span>&#160;</div>
<div class="line"><a name="l00277"></a><span class="lineno">  277</span>&#160;               <span class="keywordflow">if</span> (messCode == REMOVE_OUT_EDGE)</div>
<div class="line"><a name="l00278"></a><span class="lineno">  278</span>&#160;                  <a class="code" href="classTIGLMutationManager.html#a6ddb2bb4d75734599ef7a39fd0291b8e">dataManager</a>-&gt;removeOutEdge(src, target);</div>
<div class="line"><a name="l00279"></a><span class="lineno">  279</span>&#160;               <span class="keywordflow">else</span></div>
<div class="line"><a name="l00280"></a><span class="lineno">  280</span>&#160;                  <a class="code" href="classTIGLMutationManager.html#a6ddb2bb4d75734599ef7a39fd0291b8e">dataManager</a>-&gt;removeInEdge(src, target);</div>
<div class="line"><a name="l00281"></a><span class="lineno">  281</span>&#160;               <span class="keywordflow">break</span>;</div>
<div class="line"><a name="l00282"></a><span class="lineno">  282</span>&#160;            <span class="keywordflow">case</span> UNDEFINED_MUTATION_MESSAGE:</div>
<div class="line"><a name="l00283"></a><span class="lineno">  283</span>&#160;               cout &lt;&lt; <span class="stringliteral">&quot;!!! warning in TIGLMutationManager::processMutationMessages : message  UNDEFINED_MUTATION_MESSAGE unsupported&quot;</span> &lt;&lt; endl &lt;&lt; endl;</div>
<div class="line"><a name="l00284"></a><span class="lineno">  284</span>&#160;         }</div>
<div class="line"><a name="l00285"></a><span class="lineno">  285</span>&#160;      }</div>
<div class="line"><a name="l00286"></a><span class="lineno">  286</span>&#160;      messBuf-&gt;clear();   <span class="comment">// clearing the mutation message buffer at the end</span></div>
<div class="line"><a name="l00287"></a><span class="lineno">  287</span>&#160;   }</div>
<div class="line"><a name="l00288"></a><span class="lineno">  288</span>&#160;};</div>
<div class="line"><a name="l00289"></a><span class="lineno">  289</span>&#160;</div>
<div class="line"><a name="l00290"></a><span class="lineno">  290</span>&#160;<span class="preprocessor">#endif </span><span class="comment">/* TIGLENGINEMUTATIONMANAGER_HPP_ */</span><span class="preprocessor"></span></div>
<div class="ttc" id="classTIGLMutationManager_html_a06acf82a5e7b4c8d1277bd2b140a1298"><div class="ttname"><a href="classTIGLMutationManager.html#a06acf82a5e7b4c8d1277bd2b140a1298">TIGLMutationManager::processMutationMessages</a></div><div class="ttdeci">void processMutationMessages(int thread=0)</div><div class="ttdoc">Processes all mutation messages at a given superstep. </div><div class="ttdef"><b>Definition:</b> tiglMutationManager.hpp:124</div></div>
<div class="ttc" id="classTIGLMutationManager_html_a6ddb2bb4d75734599ef7a39fd0291b8e"><div class="ttname"><a href="classTIGLMutationManager.html#a6ddb2bb4d75734599ef7a39fd0291b8e">TIGLMutationManager::dataManager</a></div><div class="ttdeci">DATA_CONTAINER_TYPE * dataManager</div><div class="ttdoc">pointer to the data manager object </div><div class="ttdef"><b>Definition:</b> tiglMutationManager.hpp:93</div></div>
<div class="ttc" id="classTIGLMutationManager_html"><div class="ttname"><a href="classTIGLMutationManager.html">TIGLMutationManager</a></div><div class="ttdoc">Mutation manager class. </div><div class="ttdef"><b>Definition:</b> tiglMutationManager.hpp:57</div></div>
<div class="ttc" id="classTIGLMutationManager_html_ac7ec277f489a4961de1bba26ae72679a"><div class="ttname"><a href="classTIGLMutationManager.html#ac7ec277f489a4961de1bba26ae72679a">TIGLMutationManager::processAllMutationMessages</a></div><div class="ttdeci">void processAllMutationMessages()</div><div class="ttdoc">Processes all mutation messages of all threads. </div><div class="ttdef"><b>Definition:</b> tiglMutationManager.hpp:106</div></div>
<div class="ttc" id="tiglMutationMessage_8hpp_html"><div class="ttname"><a href="tiglMutationMessage_8hpp.html">tiglMutationMessage.hpp</a></div></div>
<div class="ttc" id="classTIGLMutationMessage_html_a183239c71e1e921ce501e10376baa0d5"><div class="ttname"><a href="classTIGLMutationMessage.html#a183239c71e1e921ce501e10376baa0d5">TIGLMutationMessage::writeSimpleEdgeMessage</a></div><div class="ttdeci">bool writeSimpleEdgeMessage(MUTATION_MESSAGE_CODE code, ID_TYPE *nbrVertex, ID_TYPE *targetVertex)</div><div class="ttdoc">Procedure for writing REMOVE edge messages. </div><div class="ttdef"><b>Definition:</b> tiglMutationMessageImplementation.hpp:570</div></div>
<div class="ttc" id="classTIGLMutationMessage_html"><div class="ttname"><a href="classTIGLMutationMessage.html">TIGLMutationMessage</a></div><div class="ttdoc">Core mutation Massage container class. </div><div class="ttdef"><b>Definition:</b> tiglMutationMessage.hpp:70</div></div>
</div><!-- fragment --></div><!-- contents -->
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated on Thu Jun 25 2015 11:13:52 for TI  Graph Library   (TIGL) by &#160;<a href="http://www.doxygen.org/index.html">
<img class="footer" src="doxygen.png" alt="doxygen"/>
</a> 1.8.7
</small></address>
</body>
</html>
